# wxwork spec sdk demo for python

## 目录结构说明
- README.md: 本说明
- wwspecapisdk.so: sdk
- demoloadsdk.py: demo
- start.sh: 启动脚本

## 依赖
- 目前只支持python3
- 使用前需要安装`pycryptodome`库
  ```
  pip3 install pycryptodome
  ```

## 使用说明
可直接打开调试模式进行使用。详见 [专区调试模式](https://developer.work.weixin.qq.com/document/54809)（注意：提交到专区审核，不能带相关调试的参数）
`./start.sh 1 {debug_token} {access_token}`

## 更新日志
### 2.0.5
> sdk版本要求: `>= 1.2.2`
> 此版本demo wwspecapisdk.so 版本为 `1.2.2`

- 增加分页获取会话记录接口的使用演示 `get_msg_list_by_page_id`
- `ThreadingTCPServer.request_queue_size`改为`2048`，支持高并发connect

### 2.0.4
> sdk版本要求: `>= 1.2.1`
> 此版本demo wwspecapisdk.so 版本为 `1.2.1`

- `func`为`document_list`废弃，改用`knowledge_base_list`，旧的暂时继续兼容
- 增加知识集相关接口的使用演示 `knowledge_base_*`
- 增加员工或客户名称搜索接口的使用演示 `search_contact_or_customer`
- `wework_call`逻辑调整为先本地生成notify_id，并写本地文件成功后，再调`spec_notify_app`通知应用后台来拉数据
- `start.sh`指定utf8编码方式`PYTHONIOENCODING=utf-8`

### 2.0.3
> sdk版本要求: `>= 1.1.1`
> 此版本demo wwspecapisdk.so 版本为 `1.1.1`

- 回调数据本地缓存写入子目录`/mnt/data/callback_notify/`，并支持定期清理，默认每120s清理1200s前的文件
- 使用`spec_log_info()/spec_log_error()/spec_log_debug()`打日志。详见 [专区程序开发指引](https://developer.work.weixin.qq.com/document/54006)
- start.sh支持本地调试，`./start.sh 1 {debug_token} {access_token}` 即可开启本地模式。注意：提交到专区审核的参数，不能带相关调试的参数）
- `do_async_job`读取notify_id的回调数据，改为不依赖`func_req.get("notify_id")`，而是`self.req_decode.get_notify_id()`
- demo内部错误，使用`spec_make_internal_error_rsp_data`构造返回包
